#!/usr/bin/perl

use strict;
use rdo;
use POSIX;
use Time::HiRes qw( time );

sub timed_out {
  die "Timeout!";
}

my %ptime=();

sub try {
 my ($p)=@_;

 # you can change these variables
 my $timeout=5;
 my $url="http://misc.petricek.net/_pi.php";

 my $hostname=`hostname -i`; #useless if NAT
 $hostname=~s/[\r\n]+//gm;

 $url=~m|^(http://)?([^/]+)|;
 my $urlhost=$2;
 $_=$p;
 if (/^$/) {return;}
 if (/(\S+)\s+(elite proxy|anonymous)\s+(SSL|)\s+(.*)/) {
  my $host=$1;
  my $type=$2;
  my $ssl=$3;
  my $loc=$4;
  $ssl=($ssl=~/ssl/i)+0;
  $type=($type=~/elite/i)+0;
  if ($ssl==1) {return;} #ssl not implemented yet
  my $time=time();
  my $body='';
  $SIG{ALRM} = \&timed_out;
  eval {
   alarm ($timeout);
   $body=body(get($host,$url));
   alarm (0);
  };
  $time=time()-$time;
  if ($body=~/\[HTTP_HOST\] => $urlhost/) { #proxy is probably working correctly
   $body=~s/^\s+//mg;
   $body=~s/^[^\[].*$//mg;
   if ($body=~/$hostname/) { #WTF? My IP!
    print $body;
    print "$host : proxy UNUSABLE!\n";
   } else {
    $body=~s/^\[(HTTP_CONNECTION|http_host|remote_addr|remote_port|http_user_agent)\].*$//mgi;
    $body=~s/[\r\n]+/\n/mg;
    $body=~s/^/ /gm;
    $body=~s/^ \n//;
    my $info="Latency: $time s : $host : type=$type, $loc\n$body";
    print $info;
    print OUT $info;  
    my $ktime=$time+10000;
    $ktime="$ktime $host";
    $ptime{$ktime}=$info;
    print "-> $ktime\n";

#   flush OUT;
   }
  } else {
   if ($body eq '') {
    print "$host : proxy timeout!\n";
   } else {
    print "$host : proxy broken!\n";
   }
  }
 } else {
  print "Invalid line: $p\n";
 }
}

open OUT,">proxylist.filtered";
open IN,"<proxylist";
while (my $l=<IN>) {
 try($l);
}
close IN;
open IN,"<proxylist-nn";
while (my $l=<IN>) {
 try($l);
}
close IN;
close OUT;
open OUT2,">proxylist.timesort";
foreach my $key(sort keys %ptime) {
 print OUT2 $ptime{$key}; 
}
close OUT2;
